package ds_machine;

import java.awt.GridLayout;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JProgressBar;
import javax.swing.JRadioButton;
import javax.swing.JSlider;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.SwingWorker;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * Un jeux o il faut recopier une chane avant la fin d'une barre de progs
 * @author jub
 *
 */
public class Evenements extends JFrame{
	/**
	 * La longueur de la chaine  trouver
	 */
	private JSpinner spinnerLongueur; 
	/**
	 * Le bouton qui permet de lancer le jeux
	 */
	private JButton buttonStart;
	/**
	 * La barre de progression
	 */
	private JProgressBar progressBar;
	/**
	 * Le label a recopier
	 */
	private JLabel labelSource;
	/**
	 * Le zone de saisie qui devra contenir la copie de labelSource pour gagner
	 */
	private JTextField fieldCopie;
	/**
	 * La vitesse de la barre de progression
	 */
	private JSlider sliderVitesse;
	/**
	 * Une tache qui permet de faire avancer la barre de progression
	 * Sauf initication de l'nonc vous n'avez pas  l'utiliser
	 */
	private PasseLeTemps passeLeTemps;

	/**
	 * Permet de crer une fentre de jeux avec un titre
	 * @param titre
	 */
	public Evenements(String titre)
	{
		super(titre);
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setLayout(new GridLayout(6,2));

		spinnerLongueur = new JSpinner(new SpinnerNumberModel(4,4,20,1));
		ImageIcon icon = new ImageIcon("./bin/ds_machine/ressources/play.jpg");
		buttonStart = new JButton(icon);
		progressBar = new JProgressBar();
		labelSource=new JLabel();
		fieldCopie= new JTextField(20);
		sliderVitesse = new JSlider(1,10,1);
		this.init();

		//ajouter vos ecouteurs ici
		
		
		



		//ajouter vos ecouteurs avant
		this.add(new JLabel("Vitesse"));
		this.add(sliderVitesse);
		this.add(new JLabel("Longueur"));
		this.add(spinnerLongueur);
		this.add(new JLabel ("Temps restant"));
		this.add(progressBar);
		this.add(new JLabel("Source"));
		this.add(labelSource);
		this.add(new JLabel("copie"));
		this.add(fieldCopie);
		this.add(new JLabel());
		this.add(buttonStart);




		this.pack();
	}

	/**
	 * Une mthode qui permet d'initialiser la fentre
	 */
	private void init()
	{
		//la barre de progression est  zro
		this.progressBar.setValue(0);
		//le label  recopier est vide		
		this.labelSource.setText("");
		//la zone de saisie est vide
		this.fieldCopie.setText("");
		//la zone de saisie n'est pas ditable
		this.fieldCopie.setEditable(false);
		//le bouton true est actif
		this.buttonStart.setEnabled(true);
		//l'objet qui va faire avancer la barre de progression est cr
		this.passeLeTemps = new PasseLeTemps();
	}

	/**
	 * La tache responsable de l'volution de la barre de progression
	 * Vous n'avez rien  y modifier
	 * @author jub
	 *
	 */
	private class PasseLeTemps extends SwingWorker<Void, Void>
	{

		/* (non-Javadoc)
		 * @see javax.swing.SwingWorker#doInBackground()
		 */
		@Override
		protected Void doInBackground() throws Exception {
			while(progressBar.getValue()<100 && !isCancelled())
			{
				//attente
				Thread.sleep((10-(Integer) sliderVitesse.getValue())*100);
				//mise  jour de la barre de progression
				progressBar.setValue(progressBar.getValue()+(Integer) sliderVitesse.getValue());
			}
			return null;
		}

		@Override
		protected void done() {
			// TODO Auto-generated method stub
			super.done();
			//Si nous n'avons pas t annul, nous avons perdu
			if (!this.isCancelled())
			{
				JOptionPane.showMessageDialog(Evenements.this, "Perdu");
				Evenements.this.init();
			}

		}


	}
	/**
	 * @param longueur la longeur de la chane  gnrer
	 * @return la chane gnre
	 */
	private String genaration(int longueur)
	{
		String res ="";

		for (int i=0; i < longueur; i++)
			res = res + (char) ((int) 'A' + (int) (Math.random()*25));
		return res;
	}

	//Mettre votre ou vos classes internes aprs
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

	//Mettre vos ou votre classe interne avant



}
